#Include "Rwmake.ch" 
#Include "TopConn.CH"
#Include "TbiConn.CH"

/*


ͻ
͹
Descricao  Gera Pre Nota Fiscal de Entrada com Base na Nota Fiscal.    
͹


*/

User Function ExpNfsNfe

/*Ŀ
                   Declara as Variaveis Utilizadas na Rotina                  
  */

Private cPerg     := "EXPNFSNFE "
Private nOpc      := 0
Private cCadastro := "Rotina de Geracao de Pre-Nota de Entrada"
Private aSay      := {}
Private aArea     := GetArea()
Private aButton   := {} 

/*Ŀ
             Verifica se o Grupo de Perguntas existe ou nao                   
  */

ValidPerg( cPerg )

/*Ŀ
                 Carrega o Grupo de Perguntas na Tela                         
  */

Pergunte( cPerg , .F. )

/*Ŀ
             Monta a Janela de Dialogo com as Mensagens Explicativas          
  */

aAdd ( aSay , "                                                                                        " )
aAdd ( aSay , "Essa rotina tem como objetivo Gerar Pre Notas de Entrada com base em Notas de Saida.    " )
aAdd ( aSay , "Apenas as Notas que tiverem Pedidos de Vendas com Flag de Geracao ( C5_PRENF ) serao    " )
aAdd ( aSay , "terao suas Notas Fiscais de Saida consideradas para a Geracao da Pre Nota de Entrada    " )
aAdd ( aSay , "na outra empresa do Grupo.                                                              " )
aAdd ( aSay , "                                                                                        " )
aAdd ( aSay , "                                                                                        " )
aAdd ( aSay , "                                                                                        " )

/*Ŀ
                Monta a os Botoes a serem Disponibilizados na Tela            
  */

aAdd ( aButton , { 1 , .T. , { || nOpc := 1  , FechaBatch() }} )
aAdd ( aButton , { 2 , .T. , { || FechaBatch()              }} )
aAdd ( aButton , { 5 , .T. , { || Pergunte( cPerg , .T. )   }} )

/*Ŀ
                Abre a Tela para o Processamento das Opcoes                   
  */

FormBatch( cCadastro , aSay , aButton )

/*Ŀ
       Caso o Usuario Tenha acessado o Botao de Ok inicia o processamento     
  */

If nOpc == 1

   If Aviso("Ateno !" , "Confirma a Gerao das Pr-Notas ? " , {"Sim","No"} , 1 , "Confirma o Processamento ?" ) ==  1 
      Processa( { |lEnd| u_SelNfsNfe() } , "Gerao de Pr-Notas " , "Aguarde..." , .T. )
   Endif   

Endif   

/*Ŀ
   Fecha os Arquivos Temporarios e Restaura as Areas Antes da Execucao da Rotina  
  */

RestArea(aArea)

Return                      

/*


ͻ
͹
Descricao  Seleciona as Notas Fiscais de Saida para a Geracao da Pre    
           Nota de Entrada.                                             
͹


*/

User Function SelNfsNfe()

/*Ŀ
                   Declara as Variaveis Utilizadas na Rotina                  
  */

Local cQuery     := ""                       
Local cDocumento := ""
Local cSerie     := ""
Local cCliente   := ""
Local cLoja      := ""
Local aCabec     := {}
Local aLinha     := {}
Local aItens     := {}
Local aInf       := {}
Local cInfEmp    := ""
Local cInfFil    := ""
Local cTipoNFE   := ""
Local nCusto
Local cFilOrigem := cFilAnt
Private aOcorr   := {}
Private cCnpjOri := SM0->M0_CGC
Private cCodFor := ""
Private cLojFOr := ""

/*Ŀ
                     Query para Selecao de Pessoas Juridicas                  
  */


cQuery := "Select SD2.D2_DOC     , SD2.D2_SERIE  , SD2.D2_EMISSAO , SD2.D2_CLIENTE , SD2.D2_LOJA  , SD2.D2_UM , SD2.D2_LOCAL , "
cQuery += "       SD2.D2_ITEM    , SD2.D2_COD    , SD2.D2_QUANT   , SD2.D2_PRCVEN  , SD2.D2_TOTAL , "
cQuery += "       SD2.D2_VALIPI  , SD2.D2_VALICM , SD2.D2_IPI     , SD2.D2_PICM    , SD2.D2_TES   , "
cQuery += "       SC5.C5_CODEMP , SC5.C5_CODFIL, SC5.C5_XTIPONF  "
cQuery += " From  " + RetSqlName("SD2") + " SD2 , " + RetSqlName("SC5") + " SC5 "
cQuery += "  Where     SC5.C5_NUM    = SD2.D2_PEDIDO "
cQuery += "        And SC5.C5_PRENF  = '1' "
cQuery += "        And SD2.D2_FILIAL = SC5.C5_FILIAL "
cQuery += "        And SD2.D2_DOC BetWeen '" + MV_PAR01 + "' And '" + MV_PAR02 + "' "
cQuery += "        And SD2.D2_EMISSAO BetWeen '" + DtoS( MV_PAR04 ) + "' And '" + DtoS ( MV_PAR05 ) + "' "
cQuery += "        And SD2.D2_SERIE = " + "'" + MV_PAR03 + "'"
cQuery += "        And SD2.D_E_L_E_T_ = ''"
cQuery += "        And SC5.D_E_L_E_T_ = ''"

/*Ŀ
                  Chama a Funcao que Readequa a Query                         
  */

cQuery :=  ChangeQuery( cQuery )

/*Ŀ
      Gera a Query em Arquivo Texto para Analises pelo Query Analyser         
  */

Memowrite("ExpNfsNfe.Sql" , cQuery )

/*Ŀ
                   Abre o Resultado da Query no Alias QRY                     
  */

TcQuery cQuery New Alias "NFS_QRY"

/*Ŀ
                  Ajusta os Campos Apos a Execucao da Query                      
  */

TcSetField( "NFS_QRY" , "D2_EMISSAO" , "D" , 08 , 0 )
TcSetField( "NFS_QRY" , "D2_QUANT"   , "N" , 14 , 2 )
TcSetField( "NFS_QRY" , "D2_PRCVEN"  , "N" , 14 , 5 )
TcSetField( "NFS_QRY" , "D2_TOTAL"   , "N" , 14 , 2 )
TcSetField( "NFS_QRY" , "D2_VALIPI"  , "N" , 14 , 2 )
TcSetField( "NFS_QRY" , "D2_VALICM"  , "N" , 14 , 2 )
TcSetField( "NFS_QRY" , "D2_IPI"     , "N" , 12 , 2 )
TcSetField( "NFS_QRY" , "D2_PICM"    , "N" , 12 , 2 )

/*Ŀ
                         Localiza cdigo da empresa origem como fornecedor		
  */
DbSelectArea("SA2")
DbSetOrder(3)
If dbseek ( xFilial("SA2") + cCnpjOri )
  cCodFor := SA2->A2_COD
  cLojFOr := SA2->A2_LOJA
else
	MsgBox("O CNPJ " + Transf(cCnpjOri,"@R 99.999.999/9999-99") + " no est cadastrado como fornecedor na filial destino.","Ateno","INFO")
	If Select("NFS_QRY") > 0
	   DbSelectArea("NFS_QRY")
	   DbCloseArea()
	EndIf
	Return()
Endif


/*Ŀ
                         Appenda a Query na Tabela                            
  */
DbSelectArea("NFS_QRY")
DbGotop()
ProcRegua( NFS_QRY->( Reccount() ) )   



/*Ŀ
                       Processa os Itens da Nota Fiscal                       
  */

Do While NFS_QRY->( !Eof() )
                           
/*Ŀ
                      Adiciona a Regua de Processamento                       
  */

  IncProc( "Gerando a Pr-Nota Nmero : " + NFS_QRY->D2_DOC )

/*Ŀ
                 Guarda os Dados da Nota que Sera Processada                      
  */

   cInfEmp    := NFS_QRY->C5_CODEMP
   cInfFil    := NFS_QRY->C5_CODFIL
   cDocumento := NFS_QRY->D2_DOC
   cSerie     := NFS_QRY->D2_SERIE
   cCliente   := NFS_QRY->D2_CLIENTE
   cLoja      := NFS_QRY->D2_LOJA
   cTipoNFE	  := NFS_QRY->C5_XTIPONF
   aItens     := {}
   aCabec     := {}
   aLinha     := {}

/*Ŀ
              Monta o Array com o Cabecalho da Nota Fiscal de Entrada             
  */

   aCabec :=   {	{"F1_TIPO",		NFS_QRY->C5_XTIPONF,	Nil },;
		    		{"F1_FORMUL",	"N",					Nil },;
					{"F1_DOC",		NFS_QRY->D2_DOC,		Nil },;
			  		{"F1_SERIE",	NFS_QRY->D2_SERIE,		Nil },;
					{"F1_EMISSAO",	NFS_QRY->D2_EMISSAO,	Nil },;
					{"F1_FORNECE",	cCodFor,				Nil },;
					{"F1_LOJA",		cLojFOr,				Nil },;
					{"F1_ESPECIE",	"SPED",					Nil }	}
				  

/*Ŀ
               Armazena todos os itens da Nota de Saida no Array              
  */
   Do While NFS_QRY->( !Eof() ) .And. NFS_QRY->D2_DOC     == cDocumento ;
                                 .And. NFS_QRY->D2_SERIE   == cSerie     ;
                                 .And. NFS_QRY->D2_CLIENTE == cCliente   ;
                                 .And. NFS_QRY->D2_LOJA    == cLoja

	//Busca custo do item
	nCusto := ( FINDCUSTO(NFS_QRY->D2_COD, cFilOrigem) * NFS_QRY->D2_QUANT )

   /*Ŀ
                     Monta o array com os Itens da Nota de Saida                 
     */
      aLinha := {	{"D1_ITEM",		NFS_QRY->D2_ITEM, 	Nil },;
	     			{"D1_COD",		NFS_QRY->D2_COD, 	Nil },;
	     			{"D1_UM",		NFS_QRY->D2_UM, 	Nil },;
	     			{"D1_LOCAL",	NFS_QRY->D2_LOCAL, 	Nil },;
			    	{"D1_QUANT",	NFS_QRY->D2_QUANT, 	Nil },;
				   	{"D1_VUNIT",	NFS_QRY->D2_PRCVEN,	Nil },;
					{"D1_TOTAL",	NFS_QRY->D2_TOTAL,	Nil },;
					{"D1_EMISSAO",	dDataBase, 			Nil },;
					{"D1_VALIPI",	NFS_QRY->D2_VALIPI,	Nil },;
					{"D1_VALICM",	NFS_QRY->D2_VALICM,	Nil },;
					{"D1_IPI",		NFS_QRY->D2_IPI,	Nil },;
					{"D1_PICM",		NFS_QRY->D2_PICM,	Nil },;
					{"D1_CUSGAMA",	nCusto, 			Nil }	}

   /*Ŀ
                  Adiciona no Array com todos os Itens da Nota                   
     */
      Aadd ( aItens , aLinha )

   /*Ŀ
                  Processa o Proximo Item da Nota Fiscal de Saida                
     */
      DbSkip()
      Loop

   Enddo
   
 /*Ŀ
                Chama a Rotina que Gera a Pre Nota de Entrada                  
   */

   StartJob( "u_PrcNfsNfe" , GetEnvServer() , .T. , cInfEmp , cInfFil , aCabec , aItens )
   DbSelectArea("NFS_QRY") 
   Loop

Enddo

/*Ŀ
   Fecha os Arquivos Temporarios e Restaura as Areas Antes da Execucao da Rotina  
  */

If Select("NFS_QRY") > 0
   DbSelectArea("NFS_QRY")
   DbCloseArea()
EndIf

Aviso( "Gerao de Pr Notas de Entradao !" , "Verifique o Log do Processamento na Pasta C:\TEMP\" , {"Ok"} , 1 , "Final do Processamento" )

Return

/*


͹
Descricao  Processa a Gerao da Pre Nota Fiscal de Entrada com base    
           na Nota Fiscal de Saida.                                     
͹


*/

User Function PrcNfsNfe( cEmp , cFil , aCab , aIte )

/*Ŀ
                   Declara as Variaveis Utilizadas na Rotina                  
  */

Local   aArea           := GetArea()
Local   cFile           := ""
Private nModulo         := 99
Private nOpc            :=  3
Private lRefresh        := .T.
Private lMsErroAuto		:= .F.
Private lMsHelpAuto		:= .T.
Private lAutoErrNoFile	:= .F.     
Private __cInterNet     := Nil
Private cTxtErro        := ""

MakeDir("C:\TEMP")


/*Ŀ
               Abre a Empresa Destino Onde a Pre Nota Sera Gerada             
  */

Prepare Environment Empresa cEmp Filial cFil User 'siga' PassWord 't58220' Modulo "EST" Tables "SF1","SD1","SA1","SA2","SB1","SB2","SF4"

/*Ŀ
             Verifica se existem Itens para Geracao da Pre Nota de Entrada        
  */

If Len ( aCab ) > 0 .And. Len ( aIte ) > 0

   MsAguarde({|| MSExecAuto({ | x , y , z | MATA140( x , y , z )} , aCab , aIte , 3 ) } , "Gerando Pre-Nota de Entrada" )

 /*Ŀ
                      Chama a Rotina que exibe as Mensagens de Erro                
   */
         
	If !lMsErroAuto
		Conout( "*** Pr Nota Fiscal Incluida com Sucesso !! ***" )
		cTxtErro := MostraErro()
		cFile := 'NF_' + aCab[3][2] + '_OK' + ".LOG"
		Memowrite( cFile, cTxtErro )
		Memowrite( "C:\TEMP\" + cFile, cTxtErro )
		
	Else
		Conout( "*** Erro na Incluso da Pr Nota !! ***")
		cTxtErro := MostraErro()
		cFile := 'NF_' + aCab[3][2] + '_REJ' + ".LOG"
		Memowrite( cFile, cTxtErro )
		Memowrite( "C:\TEMP\" + cFile, cTxtErro )

		if MsgBox("Deseja ler o log (C:\TEMP\" + cFile + ") de inconsistncias do processamento?","Informao","YESNO")
			if file("C:\WINDOWS\NOTEPAD.EXE")
				WinExec("C:\WINDOWS\NOTEPAD.EXE C:\TEMP\" + cFile, 3)
			else
				WinExec("C:\WINNT\NOTEPAD.EXE C:\TEMP\" + cFile, 3)
			endif
		endif
	EndIf

Endif

Reset Environment
  
Return
            
/*


͹
Descricao Gatilho que Retorna se eh uma empresa do Grupo no campo      
          C5_PRENF da tela do Pedido de Vendas.                       .
͹


*/

User Function GatVerEmp( cCodCli , cLojCli )

/*Ŀ
   Declaracao de Variaveis Utilizadas na Rotina                        
  */

Local aVerEmp := {}
Local cRet

/*Ŀ
             Chama a Funcao que Verifica se eh uma Empresa do Grupo           
  */

aVerEmp := u_GenVerEmp( cCodCli , cLojCli )

/*Ŀ
                       Atribui as Variaveis de Tela                           
  */

cRet         	:= Iif ( aVerEmp[1][1] == .F. , "2" , "1" ) 
M->C5_PRENF  	:= Iif ( aVerEmp[1][1] == .F. , "2" , "1" ) 
M->C5_CODEMP 	:= 	aVerEmp[1][2]
M->C5_CODFIL 	:= 	aVerEmp[1][3]
M->C5_XTIPONF 	:=	aVerEmp[1][4]

/*Ŀ
                       Retorna se e uma Empresa do Grupo                      
  */

Return cRet

/*


͹
Descricao Verifica se o cliente informado existe no cadastro de        
          empresas do sistema de acordo com seu Cnpj cadastrado no SM0.
͹
Parametros cCodCli  - Codigo do Cliente                                
           cLojCli  - Loja do Cliente                                  
͹
Retorno   * Array contendo as informacoes da Empresa do Grupo          
                                                                       
            - Variavel Logica Indicando se eh uma Empresa do Grupo     
            - Codigo da Empresa                                        
            - Filial da Empresa                                        
͹


*/

User Function GenVerEmp( cCodCli , cLojCli )

/*Ŀ
   Declaracao de Variaveis Utilizadas na Rotina                        
  */

Local aAmbAtu   := GetArea()                      
Local aAmbEmp   := SM0->(GetArea())              
Local aAmbSa1   := SA1->(GetArea())              
Local cCnpjCli  := ""                             
Local aDadEmp   := {}
Local lTem      := .F.

/*Ŀ
                   Abre o Cadastro de Clientes - SA1                   
  */

DbSelectArea("SA1")
DbSetOrder(1)       //  A1_FILIAL + A1_COD + A1_LOJA

 /*Ŀ
                Posiciona no Cadastro de Clientes - SA1                 
   */

If DbSeek( xFilial("SA1") + cCodCli + cLojCli )
   cCnpjCli := SA1->A1_CGC
Endif

/*Ŀ
                    Abre o Cadastro de Empresas - SM0                  
  */

DbSelectArea("SM0")
DbSetOrder(1)       //  M0_CODIGO + M0_FILIAL       
DbGoTop()

/*Ŀ
   Processa todas as Empresas existentes no cadastro de empresas       
  */

Do While SM0->( !Eof() ) .And. !lTem
   
/*Ŀ
      Verifica se existe alguma empresa com o mesmo Cnpj do Cliente    
  */

   If cCnpjCli == SM0->M0_CGC

  /*Ŀ
      Avisa no Pedido de Vendas que sera gerada uma Pre Nota de Entrada  
    */

	If Funname() == "MATA410"

        /*Ŀ
                      Caso Encontre a Empresa Alimenta as Variaveis            
          */
		if !l410Auto
			If Aviso("Empresa do Grupo" , "O cliente selecionado no Pedido de Vendas  uma Empresa do Grupo. Confirma a Gerao de Pr-Nota de Entrada na Empresa / Filial : " + Alltrim( SM0->M0_NOME ) + " - " + Alltrim( SM0->M0_FILIAL ) + " ? " , { "Sim" , "No" } , 1 , "Selecione a Filial" ) == 1
				If Aviso("Importante!" , "Qual o tipo da Pr-Nota a ser gerada ?" , { "Normal" , "Beneficiamento" } , 1 , "Selecione o tipo da Pr-Nota" ) == 1
					Aadd( aDadEmp , {  .T. , SM0->M0_CODIGO , SM0->M0_CODFIL , "N" }  )
					lTem := .T.
				Else
					Aadd( aDadEmp , {  .T. , SM0->M0_CODIGO , SM0->M0_CODFIL , "B" }  )
					lTem := .T.
				Endif
			Endif
        
		else
		
			lTem := .T.
			
		endif   
                    
   Endif

Endif
 /*Ŀ
                     Proxima empresa cadastrada                         
   */

   DbSkip()
   Loop

Enddo

/*Ŀ
             Caso nao seja empresa do grupo , retorna .F.              
  */

If Len ( aDadEmp ) == 0
   Aadd ( aDadEmp , {  .F. , "" , "" , ""}  )
Endif

/*Ŀ
                    Restaura os Ambientes Anteriores                   
  */

RestArea( aAmbEmp )
RestArea( aAmbSA1 )
RestArea( aAmbAtu )

Return aDadEmp

/*


ͻ
͹
Descricao  Cria o Grupo de Perguntas conforme Array                    
                                                                       
͹


*/

Static Function ValidPerg( cPerg )

/*Ŀ
              Declara as Variaveis Locais Utilizadas na Rotina                
  */

  Local aRegs := {}

/*
Ŀ
            Adiciona as Perguntas no Array a ser Gravado no SX1             

*/

aAdd( aRegs , { cPerg , "01" , "Da Nota Fiscal            ?    " , "            " , "            " , "MV_CH1" , "C" , 09 , 0 , 0 , "G" , "" , "MV_PAR01" , "" , "" , "" , "" , "" , "" , "" , "" , "" , "" , "" , "" , "" , "" , "" , "" , "" , "" , "" , "" , "" , "" , "" , "" , "" , ""})
aAdd( aRegs , { cPerg , "02" , "Ate a Nota Fiscal         ?    " , "            " , "            " , "MV_CH2" , "C" , 09 , 0 , 0 , "G" , "" , "MV_PAR02" , "" , "" , "" , "" , "" , "" , "" , "" , "" , "" , "" , "" , "" , "" , "" , "" , "" , "" , "" , "" , "" , "" , "" , "" , "" , ""})
aAdd( aRegs , { cPerg , "03" , "Qual a Serie              ?    " , "            " , "            " , "MV_CH3" , "C" , 03 , 0 , 0 , "G" , "" , "MV_PAR03" , "" , "" , "" , "" , "" , "" , "" , "" , "" , "" , "" , "" , "" , "" , "" , "" , "" , "" , "" , "" , "" , "" , "" , "" , "" , ""})
aAdd( aRegs , { cPerg , "04" , "Da Data de Emissao        ?    " , "            " , "            " , "MV_CH4" , "D" , 08 , 0 , 0 , "G" , "" , "MV_PAR04" , "" , "" , "" , "" , "" , "" , "" , "" , "" , "" , "" , "" , "" , "" , "" , "" , "" , "" , "" , "" , "" , "" , "" , "" , "" , ""})
aAdd( aRegs , { cPerg , "05" , "Ate a Data de Emissao     ?    " , "            " , "            " , "MV_CH5" , "D" , 08 , 0 , 0 , "G" , "" , "MV_PAR05" , "" , "" , "" , "" , "" , "" , "" , "" , "" , "" , "" , "" , "" , "" , "" , "" , "" , "" , "" , "" , "" , "" , "" , "" , "" , ""})


/*Ŀ
              Verifica se Ja Existe Registro no SX1 e Grava                   
  */

DbSelectArea("SX1")
DbSetOrder(1)

For i := 1 to Len( aRegs )
   If !SX1->(dbSeek(cPerg+aRegs[i,2]))
      RecLock("SX1",.T.)
	  For j:=1 to FCount()
	     If j <= Len(aRegs[i])
		    FieldPut(j,aRegs[i,j])
		 Endif
	  Next
	  SX1->(MsUnlock())
   Endif
Next  

Return


/*


Ŀ
Funcao FINDCUSTO                                    Data 04.07.2011
ٱ


*/

Static Function FINDCUSTO( cProd, cFilOrigem )
Local nRet 		:= 0
Local aArea		:= GetArea()
Local aAreaSB2	:= SB2->(GetArea())
Local nDecimal	:= TamSX3("B2_CM1")[2]
Local cQuery 	:= 	"SELECT TOP 1 SUM(SB9.B9_VINI1) B9_VINI1, SUM(SB9.B9_QINI) B9_QINI " +;
					"FROM " + RetSQLName("SB9") + " SB9 " +;
					"WHERE SB9.B9_FILIAL = '" + cFilOrigem + "' " +;
							"AND SB9.B9_COD = '" + cProd + "' " +;
							"AND SB9.D_E_L_E_T_ <> '*' " +;
					"GROUP BY SB9.B9_DATA " +;
					"ORDER BY SB9.B9_DATA DESC"

SB2->( dbSetOrder(1) )

//Ŀ
// Verificando se a existencia da area TRB      
//

if Select("TRB") > 0
	dbSelectArea("TRB") 
	dbCloseArea()
endif

//Ŀ
// Criando a tabela temporaria                  
//

cQuery := ChangeQuery(cQuery)
dbUseArea( .T., "TOPCONN", TCGENQRY(,,cQuery),"TRB", .F., .T.)

//Ŀ
// Buscando ultimo custo fechado (SB9). Caso nao ache, busca o custo medio atual 
//

dbSelectArea("TRB")
dbGoTop()
if !eof()
	nRet := Round(TRB->B9_VINI1 / TRB->B9_QINI, nDecimal)
else
	if SB2->( dbSeek( cFilOrigem + cProd ) )
		if SB2->B2_CM1 > 0
			nRet := SB2->B2_CM1		//campo com o custo medio unitario
		endif
	endif
endif

//Ŀ
// Verificando se a existencia da area TRB      
//

if Select("TRB") > 0
	dbSelectArea("TRB") 
	dbCloseArea()
endif

RestArea(aAreaSB2)
RestArea(aArea)
Return(nRet)